
ChiliProject - Feature # 170: [PATCH] Extensible MailHandler 

Status: Closed Priority: Normal
Author: Yuki Sonoda Category: Mail Receiving
Created: 2011-02-10 Assignee: Eric Davis
Updated: 2011-02-17 Due date:
Remote issue URL: http://www.redmine.org/issues/7598
Affected version:
Description: app/models/mail_handler is useful but not extensibly from plugins. I think it would be useful if MailHandler 

were extensible by making a subclass based on it.

I wrote the attached patch. This introduces MailHandler#dispatch_to_default which just calls receive_issue by 
default. Plugin can extend the dispatch table by overriding #dispatch_to_default.

Associated revisions
2011-02-15 12:48 am - Eric Davis
[#170] Refactor MailHandler to support a default dispatch method

Contributed by Yuki Sonoda

History
2011-02-10 09:00 am - Felix Schäfer
Couldn't you currently extend the model and replace/extend @#receive_issue@ with an @alias_method_chain@?

2011-02-10 09:11 am - Holger Just
Felix SchÃ¤fer wrote:
> Couldn't you currently extend the model and replace/extend @#receive_issue@ with an @alias_method_chain@?

@alias_method_chain@ is a really hacky solution which is abused with great virtuosity in Redmine/ChiliProject plugins and creates a lot of pain 
sometimes. So if we have the opportunity to have an actual extensible API, we should really go for it.

2011-02-10 11:43 pm - Eric Davis
- Status changed from Open to Ready for review

I also thought about @alias_method_chain@ but if I recall ActionMailer classes do some funky tricks for their methods (partial singleton, class 
methods...).  This makes patching is more difficult.

Having an overall extensible API for mail receiving is actually a great idea. Then plugins can hook into there to process their own email (e.g. like 
replying to the emails my Question plugin generates). I think Yuki Sonoda's patch is the simplest thing that could work.

2011-02-14 11:59 pm - Eric Davis
- Assignee set to Eric Davis

I've added Yuki's patch to a branch along with some rdoc comments. Ready for review.

https://github.com/edavis10/chiliproject/tree/ticket/master/170-mail-handler-dispatch

2011-02-15 01:34 pm - Felix Schäfer
Looks good to me, merge at will.

2011-02-17 01:11 am - Eric Davis
- Target version set to 1.1.0 â€” Bell

- Status changed from Ready for review to Closed

Merged into master for 1.1.0. Thank you for the patch Yuki Sonoda.
